diff --git a/xlators/features/upcall/src/upcall-internal.c b/xlators/features/upcall/src/upcall-internal.c
index 4c9450008ec..9c43b987d0e 100644
--- a/xlators/features/upcall/src/upcall-internal.c
+++ b/xlators/features/upcall/src/upcall-internal.c
@@ -449,12 +449,14 @@ up_invalidate_needed(dict_t *xattrs)
  *
  * Since sending notifications for cache_invalidation is a best effort,
  * any errors during the process are logged and ignored.
+ *
+ * The function should be called only if upcall is enabled
  */
 void
 upcall_cache_invalidate(call_frame_t *frame, xlator_t *this, client_t *client,
-                        inode_t *inode, uint32_t flags, struct iatt *stbuf,
-                        struct iatt *p_stbuf, struct iatt *oldp_stbuf,
-                        dict_t *xattr)
+                        inode_t *inode, const uint32_t flags,
+                        struct iatt *stbuf, struct iatt *p_stbuf,
+                        struct iatt *oldp_stbuf, dict_t *xattr)
 {
     upcall_client_t *up_client_entry = NULL;
     upcall_client_t *tmp = NULL;
@@ -463,9 +465,6 @@ upcall_cache_invalidate(call_frame_t *frame, xlator_t *this, client_t *client,
     time_t time_now;
     inode_t *linked_inode = NULL;
 
-    if (!is_upcall_enabled(this))
-        return;
-
     /* server-side generated fops like quota/marker will not have any
      * client associated with them. Ignore such fops.
      */
diff --git a/xlators/features/upcall/src/upcall.c b/xlators/features/upcall/src/upcall.c
index 60189e97229..557642a8ee1 100644
--- a/xlators/features/upcall/src/upcall.c
+++ b/xlators/features/upcall/src/upcall.c
@@ -30,7 +30,6 @@ up_open_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int32_t op_ret,
             int32_t op_errno, fd_t *fd, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -41,9 +40,9 @@ up_open_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int32_t op_ret,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, NULL,
-                            NULL, NULL, NULL);
+
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_UPDATE_CLIENT,
+                            NULL, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(open, frame, op_ret, op_errno, fd, xdata);
@@ -83,18 +82,19 @@ up_writev_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
               dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
+    EXIT_IF_UPCALL_OFF(this, out);
+
     client = frame->root->client;
     local = frame->local;
 
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = UP_WRITE_FLAGS;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, postbuf,
-                            NULL, NULL, NULL);
+
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_WRITE_FLAGS,
+                            postbuf, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(writev, frame, op_ret, op_errno, prebuf, postbuf,
@@ -137,7 +137,6 @@ up_readv_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
              struct iobref *iobref, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -148,9 +147,9 @@ up_readv_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, stbuf,
-                            NULL, NULL, NULL);
+
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_UPDATE_CLIENT,
+                            stbuf, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(readv, frame, op_ret, op_errno, vector, count, stbuf,
@@ -190,7 +189,6 @@ up_lk_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int32_t op_ret,
           int32_t op_errno, struct gf_flock *lock, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -201,9 +199,9 @@ up_lk_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int32_t op_ret,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, NULL,
-                            NULL, NULL, NULL);
+
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_UPDATE_CLIENT,
+                            NULL, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(lk, frame, op_ret, op_errno, lock, xdata);
@@ -242,7 +240,6 @@ up_truncate_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
                 dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -253,9 +250,9 @@ up_truncate_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = UP_WRITE_FLAGS;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, postbuf,
-                            NULL, NULL, NULL);
+
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_WRITE_FLAGS,
+                            postbuf, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(truncate, frame, op_ret, op_errno, prebuf, postbuf,
@@ -365,7 +362,6 @@ up_rename_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int32_t op_ret,
               struct iatt *postnewparent, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -376,20 +372,19 @@ up_rename_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int32_t op_ret,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = (UP_RENAME_FLAGS | UP_PARENT_DENTRY_FLAGS);
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, stbuf,
+
+    upcall_cache_invalidate(frame, this, client, local->inode,
+                            (UP_RENAME_FLAGS | UP_PARENT_DENTRY_FLAGS), stbuf,
                             postnewparent, postoldparent, NULL);
 
-    flags = UP_UPDATE_CLIENT;
     upcall_cache_invalidate(frame, this, client, local->rename_oldloc.parent,
-                            flags, postoldparent, NULL, NULL, NULL);
+                            UP_UPDATE_CLIENT, postoldparent, NULL, NULL, NULL);
 
     if (local->rename_oldloc.parent == local->loc.parent)
         goto out;
 
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->loc.parent, flags,
-                            postnewparent, NULL, NULL, NULL);
+    upcall_cache_invalidate(frame, this, client, local->loc.parent,
+                            UP_UPDATE_CLIENT, postnewparent, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(rename, frame, op_ret, op_errno, stbuf, preoldparent,
@@ -433,7 +428,6 @@ up_unlink_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
               dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -444,13 +438,13 @@ up_unlink_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = (UP_NLINK_FLAGS | UP_PARENT_DENTRY_FLAGS);
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, NULL,
+
+    upcall_cache_invalidate(frame, this, client, local->inode,
+                            (UP_NLINK_FLAGS | UP_PARENT_DENTRY_FLAGS), NULL,
                             postparent, NULL, NULL);
 
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->loc.parent, flags,
-                            postparent, NULL, NULL, NULL);
+    upcall_cache_invalidate(frame, this, client, local->loc.parent,
+                            UP_UPDATE_CLIENT, postparent, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(unlink, frame, op_ret, op_errno, preparent, postparent,
@@ -491,7 +485,6 @@ up_link_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
             struct iatt *preparent, struct iatt *postparent, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -502,13 +495,13 @@ up_link_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = (UP_NLINK_FLAGS | UP_PARENT_DENTRY_FLAGS);
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, stbuf,
+
+    upcall_cache_invalidate(frame, this, client, local->inode,
+                            (UP_NLINK_FLAGS | UP_PARENT_DENTRY_FLAGS), stbuf,
                             postparent, NULL, NULL);
 
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->loc.parent, flags,
-                            postparent, NULL, NULL, NULL);
+    upcall_cache_invalidate(frame, this, client, local->loc.parent,
+                            UP_UPDATE_CLIENT, postparent, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(link, frame, op_ret, op_errno, inode, stbuf, preparent,
@@ -550,7 +543,6 @@ up_rmdir_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
              dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -562,13 +554,12 @@ up_rmdir_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
         goto out;
     }
 
-    flags = (UP_NLINK_FLAGS | UP_PARENT_DENTRY_FLAGS);
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, NULL,
+    upcall_cache_invalidate(frame, this, client, local->inode,
+                            (UP_NLINK_FLAGS | UP_PARENT_DENTRY_FLAGS), NULL,
                             postparent, NULL, NULL);
 
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->loc.parent, flags,
-                            postparent, NULL, NULL, NULL);
+    upcall_cache_invalidate(frame, this, client, local->loc.parent,
+                            UP_UPDATE_CLIENT, postparent, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(rmdir, frame, op_ret, op_errno, preparent, postparent,
@@ -609,7 +600,6 @@ up_mkdir_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
              struct iatt *preparent, struct iatt *postparent, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -622,13 +612,11 @@ up_mkdir_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
     }
 
     /* invalidate parent's entry too */
-    flags = UP_TIMES;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags,
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_TIMES,
                             postparent, NULL, NULL, NULL);
 
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->loc.inode, flags, stbuf,
-                            NULL, NULL, NULL);
+    upcall_cache_invalidate(frame, this, client, local->loc.inode,
+                            UP_UPDATE_CLIENT, stbuf, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(mkdir, frame, op_ret, op_errno, inode, stbuf, preparent,
@@ -670,7 +658,6 @@ up_create_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
               struct iatt *preparent, struct iatt *postparent, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -685,13 +672,11 @@ up_create_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
     /* As its a new file create, no need of sending notification
      * However invalidate parent's entry and update that fact that the
      * client has accessed the newly created entry */
-    flags = UP_TIMES;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags,
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_TIMES,
                             postparent, NULL, NULL, NULL);
 
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->loc.inode, flags, stbuf,
-                            NULL, NULL, NULL);
+    upcall_cache_invalidate(frame, this, client, local->loc.inode,
+                            UP_UPDATE_CLIENT, stbuf, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(create, frame, op_ret, op_errno, fd, inode, stbuf,
@@ -734,7 +719,6 @@ up_lookup_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
               struct iatt *postparent)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -745,9 +729,9 @@ up_lookup_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, stbuf,
-                            NULL, NULL, NULL);
+
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_UPDATE_CLIENT,
+                            stbuf, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(lookup, frame, op_ret, op_errno, inode, stbuf, xattr,
@@ -786,7 +770,6 @@ up_stat_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int32_t op_ret,
             int32_t op_errno, struct iatt *buf, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -797,9 +780,9 @@ up_stat_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int32_t op_ret,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, buf, NULL,
-                            NULL, NULL);
+
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_UPDATE_CLIENT,
+                            buf, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(stat, frame, op_ret, op_errno, buf, xdata);
@@ -888,7 +871,6 @@ up_access_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
               int op_errno, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -899,9 +881,9 @@ up_access_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, NULL,
-                            NULL, NULL, NULL);
+
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_UPDATE_CLIENT,
+                            NULL, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(access, frame, op_ret, op_errno, xdata);
@@ -941,7 +923,6 @@ up_readlink_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
                 dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -952,9 +933,9 @@ up_readlink_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, stbuf,
-                            NULL, NULL, NULL);
+
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_UPDATE_CLIENT,
+                            stbuf, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(readlink, frame, op_ret, op_errno, path, stbuf, xdata);
@@ -994,7 +975,6 @@ up_mknod_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int32_t op_ret,
              struct iatt *preparent, struct iatt *postparent, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -1007,13 +987,11 @@ up_mknod_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int32_t op_ret,
     }
 
     /* invalidate parent's entry too */
-    flags = UP_TIMES;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags,
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_TIMES,
                             postparent, NULL, NULL, NULL);
 
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->loc.inode, flags, buf,
-                            NULL, NULL, NULL);
+    upcall_cache_invalidate(frame, this, client, local->loc.inode,
+                            UP_UPDATE_CLIENT, buf, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(mknod, frame, op_ret, op_errno, inode, buf, preparent,
@@ -1056,7 +1034,6 @@ up_symlink_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
                struct iatt *postparent, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -1069,13 +1046,11 @@ up_symlink_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
     }
 
     /* invalidate parent's entry too */
-    flags = UP_TIMES;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags,
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_TIMES,
                             postparent, NULL, NULL, NULL);
 
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->loc.inode, flags, buf,
-                            NULL, NULL, NULL);
+    upcall_cache_invalidate(frame, this, client, local->loc.inode,
+                            UP_UPDATE_CLIENT, buf, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(symlink, frame, op_ret, op_errno, inode, buf, preparent,
@@ -1116,7 +1091,6 @@ up_opendir_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
                int32_t op_ret, int32_t op_errno, fd_t *fd, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -1127,9 +1101,9 @@ up_opendir_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, NULL,
-                            NULL, NULL, NULL);
+
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_UPDATE_CLIENT,
+                            NULL, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(opendir, frame, op_ret, op_errno, fd, xdata);
@@ -1168,7 +1142,6 @@ up_statfs_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int32_t op_ret,
               int32_t op_errno, struct statvfs *buf, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -1179,9 +1152,9 @@ up_statfs_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int32_t op_ret,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, NULL,
-                            NULL, NULL, NULL);
+
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_UPDATE_CLIENT,
+                            NULL, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(statfs, frame, op_ret, op_errno, buf, xdata);
@@ -1220,7 +1193,6 @@ up_readdir_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
                dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -1231,9 +1203,9 @@ up_readdir_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, NULL,
-                            NULL, NULL, NULL);
+
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_UPDATE_CLIENT,
+                            NULL, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(readdir, frame, op_ret, op_errno, entries, xdata);
@@ -1273,7 +1245,6 @@ up_readdirp_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
                 dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
     gf_dirent_t *entry = NULL;
 
@@ -1285,17 +1256,18 @@ up_readdirp_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, NULL,
-                            NULL, NULL, NULL);
+
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_UPDATE_CLIENT,
+                            NULL, NULL, NULL, NULL);
 
     list_for_each_entry(entry, &entries->list, list)
     {
         if (entry->inode == NULL) {
             continue;
         }
-        upcall_cache_invalidate(frame, this, client, entry->inode, flags,
-                                &entry->d_stat, NULL, NULL, NULL);
+        upcall_cache_invalidate(frame, this, client, entry->inode,
+                                UP_UPDATE_CLIENT, &entry->d_stat, NULL, NULL,
+                                NULL);
     }
 
 out:
@@ -1362,7 +1334,6 @@ up_fallocate_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
                  struct iatt *post, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -1373,9 +1344,9 @@ up_fallocate_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = UP_WRITE_FLAGS;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, post,
-                            NULL, NULL, NULL);
+
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_WRITE_FLAGS,
+                            post, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(fallocate, frame, op_ret, op_errno, pre, post, xdata);
@@ -1416,7 +1387,6 @@ up_discard_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
                struct iatt *post, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -1427,9 +1397,9 @@ up_discard_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = UP_WRITE_FLAGS;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, post,
-                            NULL, NULL, NULL);
+
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_WRITE_FLAGS,
+                            post, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(discard, frame, op_ret, op_errno, pre, post, xdata);
@@ -1469,7 +1439,6 @@ up_zerofill_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
                 struct iatt *post, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -1480,9 +1449,9 @@ up_zerofill_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = UP_WRITE_FLAGS;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, post,
-                            NULL, NULL, NULL);
+
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_WRITE_FLAGS,
+                            post, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(zerofill, frame, op_ret, op_errno, pre, post, xdata);
@@ -1521,7 +1490,6 @@ up_seek_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
             int op_errno, off_t offset, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -1532,9 +1500,9 @@ up_seek_cbk(call_frame_t *frame, void *cookie, xlator_t *this, int op_ret,
     if ((op_ret < 0) || !local) {
         goto out;
     }
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, NULL,
-                            NULL, NULL, NULL);
+
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_UPDATE_CLIENT,
+                            NULL, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(seek, frame, op_ret, op_errno, offset, xdata);
@@ -1887,7 +1855,6 @@ up_fgetxattr_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
                  int32_t op_ret, int32_t op_errno, dict_t *dict, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -1899,9 +1866,8 @@ up_fgetxattr_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
         goto out;
     }
 
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, NULL,
-                            NULL, NULL, NULL);
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_UPDATE_CLIENT,
+                            NULL, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(fgetxattr, frame, op_ret, op_errno, dict, xdata);
@@ -1936,7 +1902,6 @@ up_getxattr_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
                 int32_t op_ret, int32_t op_errno, dict_t *dict, dict_t *xdata)
 {
     client_t *client = NULL;
-    uint32_t flags = 0;
     upcall_local_t *local = NULL;
 
     EXIT_IF_UPCALL_OFF(this, out);
@@ -1948,9 +1913,8 @@ up_getxattr_cbk(call_frame_t *frame, void *cookie, xlator_t *this,
         goto out;
     }
 
-    flags = UP_UPDATE_CLIENT;
-    upcall_cache_invalidate(frame, this, client, local->inode, flags, NULL,
-                            NULL, NULL, NULL);
+    upcall_cache_invalidate(frame, this, client, local->inode, UP_UPDATE_CLIENT,
+                            NULL, NULL, NULL, NULL);
 
 out:
     UPCALL_STACK_UNWIND(getxattr, frame, op_ret, op_errno, dict, xdata);
